unit globalMethods;


interface
  uses
    SysUtils, strUtils, windows;
    
    function getSizeOfFile(theFileName: string): real; //return the file size
    function getSizeOfDir(theDirPath: string): real; //return the file size






implementation

uses
  Dialogs;

//--------------------------------------------------------------------------------------------------------
function getSizeOfFile(theFileName: string): real;
{return the file size in ko}
 const FourGo: int64 = 4294967296; //4Go expressed in octets
 var
    F: file; //the file itself
    hFile: THandle;
    haut: int64; //high part of the file size (nber of 4Go)
    bas: int64; //low part of the file size (nber of octets < 4Go)
    intSize: int64; //filesize expressed as integer 64
 begin
    try
        //get the source file size :
        hFile:=CreateFile(pchar(theFileName),
            GENERIC_READ {or GENERIC_WRITE}, FILE_SHARE_WRITE OR FILE_SHARE_READ,
            nil, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0); //create the handle needed for getFileSize function

        if hFile <> INVALID_HANDLE_VALUE then begin
            bas := GetFileSize(hFile, @haut);
            intSize := (haut * FourGo) + bas ;//concatenation of bits from high and low part of the number
            result := StrToFloat(intToStr(intSize))/1024; //int64 to real conversion, expressed in ko
        end else //the handle is not valid !
            result := 0;

        CloseHandle(hFile); //close the file handle after it has been used

        {!!!old method no longer used due to a limitation to 4Go max size :
        AssignFile(F, theFileName);
        reset(F, 1024);
            //recsize is set to 1024 to have a filesize below in Ko (in o, the size can't be expressed as an integer !)
        result := StrToFloat(intToStr(fileSize(F))); //file size after an int to float conversion (I didn't found anything better to do that!)
        CloseFile(F);}

    except //if something go wrong
        result := 0;
    end;
 end;

//--------------------------------------------------------------------------------------------------------
function getSizeOfDir(theDirPath: string): real;
{return the dir size in Ko, but taking into account ONLY VTS_01_n.VOB files inside

theDirPath = path description. it should include the last '\' char}
 var
    fSize: real; //the total size of the directory in Ko (in fact only VOB file sizes summation)
    n: integer; //nber of the vob file currently analyzed
 begin
    try
        result := 0; //init to ok
        n := 1; //init
        //sum all vob files size :
        while FileExists(theDirPath + 'VTS_01_' + intToStr(n) + '.VOB') = true do begin //loop through all vob files inside the directory
            result := result + getSizeOfFile(theDirPath + 'VTS_01_' + intToStr(n) + '.VOB');
            inc(n); //jump to the next VOB file
        end;

    except //if something go wrong
        result := 0;
    end;
 end;

end.
