unit task;
{
______________________________________________________________________________
    define 2 objects :
        one individual task
        the collaction of all tasks
______________________________________________________________________________
}
{TurboVOB - A freeware to prepare DTH7000's video for DVD burning on computer under windows.
Copyright (C) 2005 Didier CADIOU

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program (see gpl.txt file); if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.}
interface
uses
  //personal units :

  //generic units :
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  Ttask = class(TObject)
  private
    { Dclarations prives }

  public
    { Dclarations publiques }
    //various path :
    originalVobPath: string;
    videoStreamPath: string;
    audioStreamPath: string;
    VobPath: string;
    destinationFolder: string;
    chapterListStr: string; //the ready to use string which contains chapters location (expressed in time format, separated by ',')


    //various settings :
    ToBeDemuxed: boolean; //if true a demux operation is asked for this video
    ToBeRemuxed: boolean; //if true a remux operation is asked for this video
    ToBeAuthored: boolean; //if true an authoring operation is asked for this video

    deleteOriginalVob: boolean; //if true delete the original VOB file after the demux is done
    deleteStreams: boolean; //if true delete m2v and ac3 files once the vob file has been remuxed
    deleteRemuxedVob: boolean; //if true delete the VOB file resulting from the remux process,
        //to keep only the one placed into the VIDEO_TS folder

    //other :
    constructor Create();
  end;


  TAllTask = class(Tobject)
  private
    { Dclarations prives }
    function getCount(): integer;
  public
    { Dclarations publiques }
    //various path :
    Tasks: array of Ttask; //collection of all tasks
    LastTaskID: integer; //nber of the last task done
    property Count: integer read getCount; //number of tasks to do
    procedure add(const theTask: Ttask);
    procedure delete(taskID: integer);
    procedure clear();
  end;

//====================================================================
implementation

//--------------------------------------------------------------------------------------------------------
constructor Ttask.Create();
begin
    Inherited create();
    ToBeDemuxed := true;
    ToBeRemuxed := true;
    ToBeAuthored := true;
end;

//--------------------------------------------------------------------------------------------------------
function TAllTask.getCount(): integer;
{return the nber of task currently asked}
begin
    result := Length(Tasks);
end;

//--------------------------------------------------------------------------------------------------------
procedure TAllTask.add(const theTask: Ttask);
{Add the task "theTask" inside the collection}
begin
    SetLength(Tasks, getCount + 1); //increase the array size by 1
    Tasks[getCount-1] := theTask; //place the task inside the last array element
end;

//--------------------------------------------------------------------------------------------------------
procedure TAllTask.delete(taskID: integer);
{delete the task nber taskID inside the collection}
var
    ix: integer; //loop index
begin
    for ix := 0 to (getCount -1) do begin
    //all items from taskID nber are shifted one place before (to overwrite the deleted one)
        if (ix >= taskID) and (ix < getCount-1) then begin
            tasks[ix] := tasks[ix+1]; //the current item is replaced
        end;
    end;
    SetLength(tasks, getcount -1); //the array size is decrease by one item
end;

//--------------------------------------------------------------------------------------------------------
procedure TAllTask.clear();
{Clear all tasks inside the collection}
begin
    SetLength(tasks, 0); //the array size is decrease by one item
end;


end.
